#!/bin/sh
if [ `cat /etc/version.txt` ]; then
    LOCAL_MAJOR=`cat /etc/version.txt | cut -d '.' -f 1`
    LOCAL_MINOR=`cat /etc/version.txt | cut -d '.' -f 2`
    LOCAL_LAST=`cat /etc/version.txt  | cut -d '.' -f 3`
    LOCAL_APP=`cat /etc/version.txt  | cut -d '.' -f 4`
else
    LOCAL_MAJOR=0
    LOCAL_MINOR=0
    LOCAL_LAST=0
    LOCAL_APP=0
fi
SD_MAJOR=0
SD_MINOR=0
SD_LAST=0

PACK=0
UPDATE=0
LANGUAGE=1

cd /sdcard
for line in `ls /sdcard/ | grep "install-[0-9]*[0-9]\.[0-9]*[0-9]\.[0-9]*[0-9]\.[0-9]*[0-9]"`
do
    PKG_VER=`echo $line | sed 's/-/\n/g' | grep [0-9]*[0-9]\.[0-9]*[0-9]\.[0-9]*[0-9]\.[0-9]*[0-9] | cut -d '.' -f 1-4`

    TMP_MAJOR=`echo $PKG_VER | cut -d '.' -f 1`
    TMP_MINOR=`echo $PKG_VER | cut -d '.' -f 2`
    TMP_LAST=`echo $PKG_VER | cut -d '.' -f 3`

    echo "found package: $line"
    if [[ $SD_MAJOR -lt $TMP_MAJOR -o $SD_MAJOR -eq $TMP_MAJOR -a $SD_MINOR -lt $TMP_MINOR -o $SD_MAJOR -eq $TMP_MAJOR -a $SD_MINOR -eq $TMP_MINOR -a $SD_LAST -lt $TMP_LAST ]]; then
        SD_MAJOR=$TMP_MAJOR
        SD_MINOR=$TMP_MINOR
        SD_LAST=$TMP_LAST
        PACK=$line
    fi
done

if [[ $LOCAL_MAJOR -lt $SD_MAJOR -o $LOCAL_MAJOR -eq $SD_MAJOR -a $LOCAL_MINOR -lt $SD_MINOR -o $LOCAL_MAJOR -eq $SD_MAJOR -a $LOCAL_MINOR -eq $SD_MINOR -a $LOCAL_LAST -lt $SD_LAST ]]; then
    echo "-----"
    echo "current version: $LOCAL_MAJOR.$LOCAL_MINOR.$LOCAL_LAST.$LOCAL_APP"
    echo "Installing new version: $PACK"

    if [ `cat /etc/appConfig.json | grep zh_CN` ]; then
        LANGUAGE=0
    elif [ `cat /etc/appConfig.json | grep en_US` ]; then
        LANGUAGE=1
    fi

    /usr/bin/updateInstall $LANGUAGE
    if [ -p /sdcard/install ]; then
        rm -rf /sdcard/install
    fi

    /bin/tar zxvf $PACK
    if [ $? == 0 ]; then
        /sdcard/install/bin/install.sh
        UPDATE=$?
        
        rm -rf /sdcard/install
        sync
        if [ $UPDATE -lt 0 ]; then
            /usr/bin/updateFailed $LANGUAGE
        fi
    else
        /usr/bin/updateFailed $LANGUAGE
    fi
else
    echo "no newer release"
fi

if [ $UPDATE == 1 ]; then
    shutdown
fi
